'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _HeaderStyles = require('./HeaderStyles');

var _media = require('../../theme/media');

var _default = require('../../theme/default');

var _default2 = _interopRequireDefault(_default);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = function (_Component) {
	_inherits(Header, _Component);

	function Header(props) {
		_classCallCheck(this, Header);

		var _this = _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).call(this, props));

		_this.shouldComponentUpdate = function (nextProps) {
			if (nextProps.logo.default !== _this.props.logo.default) {
				return true;
			} else return false;
		};

		_this.quickNav = function () {
			_this.setState({ quicknav: window.innerWidth < _media.ScreenSizes.tablet ? true : false });
		};

		_this.componentWillMount = function () {
			_this.quickNav();
			window.addEventListener('resize', _this.quickNav);
		};

		_this.componentWillUnmount = function () {
			window.removeEventListener('resize', _this.quickNav);
		};

		_this.renderNotification = function () {
			return _react2.default.createElement(
				'div',
				null,
				'NotiF'
			);
		};

		_this.renderAvatar = function () {
			return _react2.default.createElement(
				'div',
				null,
				'Avatar'
			);
		};

		_this.renderLogo = function () {
			return _react2.default.createElement(
				_HeaderStyles.LogoDiv,
				{ to: '/' },
				_react2.default.createElement(_HeaderStyles.LogoImg, { src: _this.props.logo.default })
			);
		};

		_this.renderSearchBar = function () {
			return _react2.default.createElement(
				'div',
				null,
				'Search'
			);
		};

		_this.state = {
			quicknav: false
		};
		return _this;
	}

	_createClass(Header, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    render = _props.render,
			    search = _props.search,
			    notification = _props.notification,
			    avatar = _props.avatar;
			// const { logo } = this.state

			var renderLogo = this.renderLogo,
			    renderSearchBar = this.renderSearchBar,
			    renderAvatar = this.renderAvatar,
			    renderNotification = this.renderNotification;

			return _react2.default.createElement(
				_HeaderStyles.HeaderDiv,
				{ quicknav: this.state.quicknav },
				this.props.children ? this.props.children : _react2.default.createElement(
					_react2.default.Fragment,
					null,
					renderLogo(),
					render && render(),
					search && renderSearchBar(),
					avatar && renderAvatar(),
					notification && renderNotification()
				)
			);
		}
	}]);

	return Header;
}(_react.Component);

Header.propTypes = {
	logo: _propTypes2.default.any,
	render: _propTypes2.default.func,
	search: _propTypes2.default.bool,
	notification: _propTypes2.default.bool,
	avatar: _propTypes2.default.bool
};

Header.defaultProps = {
	search: false,
	notification: false,
	avatar: false,
	logo: _default2.default.logo
};

exports.default = Header;