'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _MenuItem = require('./MenuComponents/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _MenuDiv = require('./MenuComponents/MenuDiv');

var _MenuDiv2 = _interopRequireDefault(_MenuDiv);

var _NotFound = require('../AppContainer/NotFound');

var _NotFound2 = _interopRequireDefault(_NotFound);

var _QuickNavigation = require('../QuickNavigation/QuickNavigation');

var _QuickNavigation2 = _interopRequireDefault(_QuickNavigation);

var _Functions = require('../utils/Functions');

var _media = require('../../theme/media');

var _Tab = require('../Tabs/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _Protected = require('../Login/Protected');

var _Protected2 = _interopRequireDefault(_Protected);

var _Menu = require('./Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _Page = require('./Page');

var _Page2 = _interopRequireDefault(_Page);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuPanel = function (_Component) {
	_inherits(MenuPanel, _Component);

	function MenuPanel(props) {
		_classCallCheck(this, MenuPanel);

		var _this = _possibleConstructorReturn(this, (MenuPanel.__proto__ || Object.getPrototypeOf(MenuPanel)).call(this, props));

		_this.componentWillMount = function () {
			_this.updateWindowSize();
			window.addEventListener('resize', _this.updateWindowSize);
		};

		_this.componentWillUnmount = function () {
			window.removeEventListener('resize', _this.updateWindowSize);
		};

		_this.updateWindowSize = function () {
			if (window.innerWidth < _media.ScreenSizes.tablet)
				//QuickNav on
				_this.setState({
					quicknav: true
				});
			if (window.innerWidth >= _media.ScreenSizes.tablet) _this.setState({
				quicknav: false
			});
		};

		_this.route = function (child) {
			return child.props.route ? child.props.route : (0, _Functions.convertLabelToRoute)(child.props.label);
		};

		_this.getFirstChildRoute = function (child) {
			var children = _react2.default.Children.toArray(child.props.children);
			if (children[0].type === _Tab2.default) {
				if (children[0].props.route !== undefined) return children[0].props.route;else {
					if (children[0].props.label) return (0, _Functions.convertLabelToRoute)(children[0].props.label);else return '';
				}
			} else return '';
		};

		_this.convertChildLabelToRoute = function (child) {
			var route = '';
			var children = _react2.default.Children.toArray(child.props.children);
			if (children[0].props.label) route = (0, _Functions.convertLabelToRoute)(children[0].props.label);
			return route;
		};

		_this.switch = function (bool) {
			return _this.setState({ quicknav: bool });
		};

		_this.setActiveMenu = function (label, id) {
			_this.setState({ activeMenu: label });
		};

		_this.renderMenuItem = function (child, index) {
			return _react2.default.createElement(_MenuItem2.default, { key: index,
				MenuID: index,
				helpID: child.props.helpID,
				active: _this.state.activeMenu === index ? true : false,
				icon: child.props.icon,
				label: child.props.label,
				route: _this.route(child) + _this.getFirstChildRoute(child),
				onClick: _this.setActiveMenu,
				arrow: _this.props.arrows });
		};

		_this.renderRoutes = function (children) {
			return children.map(function (child, i) {
				if (child.type !== _Protected2.default && (child.type === _Menu2.default || child.type === _Page2.default)) {
					return _react2.default.createElement(_reactRouterDom.Route, { key: i, path: _this.route(child), exact: child.props.exact ? child.props.exact : (0, _Functions.isExact)(_this.route(child)), route: _this.route(child), component: _this.renderChild(child, i) });
				} else {
					if (_this.props.isLoggedIn !== false) {
						var childs = _react2.default.Children.toArray(child.props.children);
						return childs.map(function (child, proti) {
							if (child.type === _Menu2.default || child.type === _Page2.default) {
								return _react2.default.createElement(_reactRouterDom.Route, { key: proti + i, path: _this.route(child), exact: child.props.exact ? child.props.exact : (0, _Functions.isExact)(_this.route(child)), route: _this.route(child), component: _this.renderChild(child, i + proti) });
							} else return null;
						});
					} else {
						return null;
					}
				}
			});
		};

		_this.renderBottomItems = function (children) {
			var BottomItems = [];
			children.forEach(function (child, index) {
				if (child.type === _Protected2.default) {
					if (_this.props.isLoggedIn !== false) {
						var childs = _react2.default.Children.toArray(child.props.children);
						childs.forEach(function (protchild, protindex) {
							if (protchild.props.bottom && !protchild.props.top) {
								if (protchild.type !== _Menu2.default && protchild !== _Page2.default) BottomItems.push(protchild);else BottomItems.push(_this.renderMenuItem(protchild, index + protindex));
							}
						});
					}
				} else {
					if (child.props.bottom && !child.props.top) if (child.type !== _Menu2.default && child.type !== _Page2.default) BottomItems.push(child);else BottomItems.push(_this.renderMenuItem(child, index));
				}
			});
			return BottomItems;
		};

		_this.renderTopItems = function (children) {
			var TopItems = [];
			children.forEach(function (child, index) {
				if (child.type === _Protected2.default) {
					if (_this.props.isLoggedIn !== false) {
						var childs = _react2.default.Children.toArray(child.props.children);
						childs.forEach(function (protchild, protindex) {
							if (!protchild.props.bottom && protchild.props.top) if (protchild.type !== _Menu2.default && protchild !== _Page2.default) TopItems.push(protchild);else TopItems.push(_this.renderMenuItem(protchild, index + protindex));
						});
					}
				} else {
					if (!child.props.bottom && child.props.top) if (child.type !== _Menu2.default && child.type !== _Page2.default) TopItems.push(child);else TopItems.push(_this.renderMenuItem(child, index));
				}
			});
			return TopItems;
		};

		_this.renderMenuItems = function (children) {
			// console.log(children)
			return children.map(function (child, index) {
				if (child.type === _Protected2.default && !child.props.bottom && !child.props.top) {
					if (_this.props.isLoggedIn === false) {
						return null;
					} else {
						var childs = _react2.default.Children.toArray(child.props.children);
						return childs.map(function (protchild, protindex) {
							if (!protchild.props.bottom && protchild.props.label && !protchild.props.top) return _this.renderMenuItem(protchild, protindex + index);else return null;
						});
					}
				} else {
					if (!child.props.bottom && !child.props.top && child.props.label) return _this.renderMenuItem(child, index);else return null;
				}
			});
		};

		_this.renderChild = function (child, index) {
			return function (_ref) {
				var match = _ref.match;
				return _react2.default.cloneElement(child, _extends({}, child.props, { quicknav: _this.state.quicknav, setActiveMenu: _this.setActiveMenu, activeMenu: _this.state.activeMenu, route: _this.route(child), MenuID: index }));
			};
		};

		_this.renderMenu = function (children) {
			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				!_this.state.quicknav ? _react2.default.createElement(
					_MenuDiv2.default,
					{
						quicknav: _this.switch,
						top: _this.renderTopItems(children),
						bottom: _this.renderBottomItems(children) },
					_this.renderMenuItems(children)
				) : _react2.default.createElement(_QuickNavigation2.default, { menus: children, loggedIn: _this.props.isLoggedIn !== undefined ? _this.props.isLoggedIn : true }),
				_react2.default.createElement(
					_reactRouterDom.Switch,
					null,
					_this.renderRoutes(children),
					_react2.default.createElement(_reactRouterDom.Route, { path: '*',
						render: _this.props.login === true ? _this.props.isLoggedIn === true ? function () {
							return _react2.default.createElement(_NotFound2.default, null);
						} : function () {
							return _react2.default.createElement(_reactRouterDom.Redirect, { to: _this.props.redirectTo });
						} : function () {
							return _react2.default.createElement(_NotFound2.default, null);
						} })
				)
			);
		};

		_this.state = {
			quicknav: false,
			disableMenuAchordeon: false,
			activeMenu: 0
		};
		return _this;
	}

	//#region Display quickNav or Menu 

	//#endregion 

	//#region Routing + Get First Child Route 

	//#endregion

	//#region State Management

	//#endregion

	//#region Rendering

	_createClass(MenuPanel, [{
		key: 'render',
		value: function render() {
			return this.renderMenu(_react2.default.Children.toArray(this.props.children));
		}

		//#endregion

	}]);

	return MenuPanel;
}(_react.Component);

MenuPanel.defaultProps = {
	login: false
};
exports.default = MenuPanel;