'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _QuickNavigationStyles = require('./QuickNavigationStyles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*  
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   Source - https://github.com/iamham/react-swipe-events 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   Updated to React@16
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

var SwipeEvents = function (_Component) {
	_inherits(SwipeEvents, _Component);

	function SwipeEvents(props, context) {
		_classCallCheck(this, SwipeEvents);

		var _this = _possibleConstructorReturn(this, (SwipeEvents.__proto__ || Object.getPrototypeOf(SwipeEvents)).call(this, props));

		_initialiseProps.call(_this);

		_this.state = { originalX: 0, originalY: 0 };
		return _this;
	}

	_createClass(SwipeEvents, [{
		key: 'render',
		value: function render() {
			var props = this.getModifiedProps();
			return _react2.default.createElement(_QuickNavigationStyles.QuickNav, props, this.props.children);
		}
	}]);

	return SwipeEvents;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.onTouchStart = function (e) {
		var touch = e.changedTouches[0];
		var current = _this2.getCurrentPosition(touch);

		_this2.setState({ originalX: current.x, originalY: current.y });
	};

	this.onTouchMove = function (e) {
		var touch = e.changedTouches[0];
		var delta = _this2.getDelta(touch);
		var current = _this2.getCurrentPosition(touch);
		_this2.props.onSwiping && _this2.props.onSwiping(e, _this2.state.originalX, _this2.state.originalY, current.x, current.y, delta.x, delta.y);
	};

	this.onTouchEnd = function (e) {
		var touch = e.changedTouches[0];
		var delta = _this2.getDelta(touch);
		var current = _this2.getCurrentPosition(touch);

		if (Math.abs(delta.x) > _this2.props.threshold) {
			if (delta.x > 0) _this2.props.onSwipedRight && _this2.props.onSwipedRight(e, _this2.state.originalX, current.x);
			if (delta.x < 0) _this2.props.onSwipedLeft && _this2.props.onSwipedLeft(e, _this2.state.originalX, current.x);
		}

		if (Math.abs(delta.y) > _this2.props.threshold) {
			if (delta.y > 0) _this2.props.onSwipedDown && _this2.props.onSwipedDown(e, _this2.state.originalY, current.y);
			if (delta.y < 0) _this2.props.onSwipedUp && _this2.props.onSwipedUp(e, _this2.state.originalY, current.y);
		}

		_this2.props.onSwiped && _this2.props.onSwiped(e, _this2.state.originalX, _this2.state.originalY, current.x, current.y, delta.x, delta.y);
		_this2.setState({ originalX: 0, originalY: 0 });
	};

	this.getCurrentPosition = function (touch) {
		return {
			x: parseInt(touch.screenX, 10),
			y: parseInt(touch.screenY, 10)
		};
	};

	this.getDelta = function (touch) {
		return {
			x: parseInt(touch.screenX, 10) - _this2.state.originalX,
			y: parseInt(touch.screenY, 10) - _this2.state.originalY
		};
	};

	this.getModifiedProps = function () {
		var props = _extends({}, _this2.props, {
			onTouchStart: _this2.onTouchStart,
			onTouchEnd: _this2.onTouchEnd,
			onTouchMove: _this2.onTouchMove
		});

		delete props.children;
		delete props.onSwiping;
		delete props.onSwiped;
		delete props.onSwipedUp;
		delete props.onSwipedDown;
		delete props.onSwipedLeft;
		delete props.onSwipedRight;
		delete props.nodeName;
		delete props.threshold;

		return props;
	};
};

SwipeEvents.defaultProps = {
	threshold: 10,
	nodeName: 'div'
};

SwipeEvents.propTypes = {
	children: _propTypes2.default.any.isRequired,
	onSwiping: _propTypes2.default.func,
	onSwiped: _propTypes2.default.func,
	onSwipedUp: _propTypes2.default.func,
	onSwipedDown: _propTypes2.default.func,
	onSwipedLeft: _propTypes2.default.func,
	onSwipedRight: _propTypes2.default.func,
	nodeName: _propTypes2.default.string,
	threshold: _propTypes2.default.number
};

exports.default = SwipeEvents;