'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.GetHelpID = exports.SetHelpID = undefined;

var _redux = require('redux');

var SET_HELP_ID = 'SetHelpID';

var setHelp = function setHelp(helpID) {
	return {
		type: SET_HELP_ID,
		payload: helpID
	};
};

var initialState = {
	helpID: 0
};
var HelpReducer = function HelpReducer() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
	var action = arguments[1];

	switch (action.type) {

		case SET_HELP_ID:
			return {

				helpID: action.payload
			};

		default:
			return state;
	}
};

var store = (0, _redux.createStore)(HelpReducer, window.__REDUX_DEVTOOLS_EXTENSION__ && window.__REDUX_DEVTOOLS_EXTENSION__());

var SetHelpID = exports.SetHelpID = function SetHelpID(id) {
	store.dispatch(setHelp(id));
};

var GetHelpID = exports.GetHelpID = function GetHelpID() {
	return store.getState().helpID;
};